/**
*U-File Explorer App
* Defined an App to manage openufileexplorer
*/
var UFileExplorerApp = UFileExplorerApp || {};  //Define OpenU-File Explorer App namespace.
/**
*Constructor UNAS App
*/
var ufile_username = "";
var ufile_jwt = "";
/**
 * Put one key function here to forbid open window else where
 * @param {*} callback  The callback function on success if required
 */
function UFile_auth(callback = null){
    request_cmd = {"cmd": "ufile_auth", "token": UToken}
    jQuery.ajax({
        url: "/apps/ufileexplorer/includes/index.php",
        type: "POST",
        async: true,
        dataType: 'json',
        contentType: 'json',
        data: JSON.encode(request_cmd),
        timeout: 20000,
        success: function (result) {
            data = result.results;
            ufile_username = data.username;
            ufile_jwt = data.auth;
            if(callback){
                callback();
            }
        },
        error: function(XMLHttpRequest, textStatus, errorThrown){
            //alert(textStatus);
        }
    });
}

UFileExplorerApp.App = function () {
    this.id = 'U-File Explorer';
    this.name = 'U-File Explorer';
    this.version = '6.0.65';
    this.active = false;
    this.menuIcon = '/apps/ufileexplorer/images/logo.png';
    this.shortcutIcon = '/apps/ufileexplorer/images/logo.png';
    var self = this;
    this.UFileExplorerAppWindow = function () {
        UFileExplorerAppWindowID = 'UFileExplorerAppWindow' + Date.now();
    	if(UNAS.CheckAppState('U-File Explorer')) {
    		return false;
        }
        function UFileExplorerKeepAlive(){
            jQuery.ajax({
                url: "/apps/ufileexplorer/includes/services_ufileexplorer.php",
                type: "POST",
                async: true,
                data: {"action": "keepalive"},
                timeout: 20000,
                complete: function(){
                    var FileExplorerWindow = window.top.UNAS.GetWindow(UFileExplorerAppWindowID);
                    if (FileExplorerWindow) {
                        setTimeout(function() {
                            UFileExplorerKeepAlive();
                        }, 10000);
                    }
                }
            });
        }

        UFile_auth(function(){
        UFileExplorerKeepAlive();
        self.window=new MUI.Window({
            id: UFileExplorerAppWindowID,
            title: UNAS._('U-File Explorer'),
            icon: '/apps/ufileexplorer/images/logo_small.png',
            loadMethod: 'iframe',
            width: 1300,
            height: 600,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [1070, 2000], 'y': [500, 1500] },
            contentURL: '/apps/ufileexplorer/index.html',
        });});
    };
    this.UFileExplorerUninstall = function (){
    	UNAS.RemoveDesktopShortcut('U-File Explorer');
    	UNAS.RemoveMenu('U-File Explorer');
    	UNAS.RemoveAppFromGroups('U-File Explorer', 'ControlPanel');
    	UNAS.RemoveAppFromApps('U-File Explorer');
    };
    //new UNAS.Menu('UNAS_App_Internet_Menu', this.name, this.menuIcon, 'U-File Explorer', '', this.UFileExplorerAppWindow);
   	new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'U-File Explorer', this.UFileExplorerAppWindow);
    //new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Internet', 'Location' : 1, "Icon": this.shortcutIcon, "Url": this.entryUrl}, {});
    var OnChangeLanguage = function (e) {
    	//UNAS.SetMenuTitle('U-File Explorer', UNAS._('U-File Explorer')); //translate menu
        UNAS.SetShortcutTitle('U-File Explorer', UNAS._('U-File Explorer'));
        if (typeof self.window !== 'undefined') {
        	UNAS.SetWindowTitle(UFileExplorerAppWindowID, UNAS._('U-File Explorer'));
        }
    };
    UNAS.LoadTranslation('/apps/ufileexplorer/languages/Translation?v=' + this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
	UNAS.CreateApp(this.name, this.shortcutIcon, this.UFileExplorerAppWindow, this.UFileExplorerUninstall);
};

new UFileExplorerApp.App();
